package ctbrec.ui.settings;

import java.util.ArrayList;
import java.util.List;

import ctbrec.Config;
import ctbrec.recorder.Recorder;
import ctbrec.sites.Site;
import ctbrec.ui.SiteUiFactory;
import ctbrec.ui.settings.api.Category;
import ctbrec.ui.settings.api.Group;
import ctbrec.ui.settings.api.Preferences;
import ctbrec.ui.settings.api.Setting;
import ctbrec.ui.tabs.TabSelectionListener;
import javafx.scene.control.Tab;

public class SettingsTab2 extends Tab implements TabSelectionListener {

    private List<Site> sites;
    private Recorder recorder;

    public SettingsTab2(List<Site> sites, Recorder recorder) {
        this.sites = sites;
        this.recorder = recorder;
        setText("Settings");
        createGui();
        setClosable(false);
    }

    private void createGui() {
        List<Category> siteCategories = new ArrayList<>();
        for (Site site : sites) {
            siteCategories.add(Category.of(site.getName(), SiteUiFactory.getUi(site).getConfigUI().createConfigPanel()));
        }

        Preferences prefs = Preferences.of(new CtbrecPreferencesStorage(Config.getInstance()),
                Category.of("General",
                        Group.of("General",
                                Setting.of("Player", "mediaPlayer"),
                                Setting.of("Start parameters", "mediaPlayerParams"),
                                Setting.of("Maximum resolution (0 = unlimited)", "maximumResolutionPlayer", "video height, e.g. 720 or 1080")),
                        Group.of("Player",
                                Setting.of("Player", "mediaPlayer"),
                                Setting.of("Start parameters", "mediaPlayerParams"),
                                Setting.of("Maximum resolution (0 = unlimited)", "maximumResolutionPlayer", "video height, e.g. 720 or 1080"),
                                Setting.of("Show \"Player Starting\" Message", "showPlayerStarting"))
                        ),
                Category.of("Sites", siteCategories.toArray(new Category[0]))
                );
        setContent(prefs.getView());
    }

    @Override
    public void selected() {
        // TODO Auto-generated method stub

    }

    @Override
    public void deselected() {
        // TODO Auto-generated method stub

    }


}
